import { Commands } from "Minecraft";

export class Utilities {
    static circle(playerName, id, radius, direction, value = 0, caret = 0, hollow = false) {
        function command(command) { try { Commands.run(command) } catch (error) { } }
        if (hollow) {
            if (direction == "x") {
                for (let i = 0; i <= radius; i++) {
                    const result = Math.round(Math.sqrt((radius * radius) - (i * i)));
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${value} ~${result} ~${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${value} ~${i} ~${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${value} ~-${result} ~-${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${value} ~-${i} ~-${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${value} ~${result} ~-${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${value} ~-${i} ~${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${value} ~-${result} ~${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${value} ~${i} ~-${result} ${id}`);
                }
            }
            else if (direction == "y") {
                for (let i = 0; i <= radius; i++) {
                    const result = Math.round(Math.sqrt((radius * radius) - (i * i)));
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${result} ~${value} ~${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${i} ~${value} ~${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~-${result} ~${value} ~-${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~-${i} ~${value} ~-${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${result} ~${value} ~-${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~-${i} ~${value} ~${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~-${result} ~${value} ~${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${i} ~${value} ~-${result} ${id}`);
                }
            }
            else if (direction == "z") {
                for (let i = 0; i <= radius; i++) {
                    const result = Math.round(Math.sqrt((radius * radius) - (i * i)));
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${result} ~${i} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${i} ~${result} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~-${result} ~-${i} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~-${i} ~-${result} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${result} ~-${i} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~-${i} ~${result} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~-${result} ~${i} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} setblock ~${i} ~-${result} ~${value} ${id}`);
                }
            }
            else {
                this.error(playerName, "方向はx, y, zのみです");
                Commands.run(`testfor @s`);
            }
        }
        else {
            if (direction == "x") {
                for (let i = 0; i <= radius; i++) {
                    const result = Math.round(Math.sqrt((radius * radius) - (i * i)));
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~${value} ~ ~ ~${value} ~${result} ~${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~${value} ~ ~ ~${value} ~${i} ~${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~${value} ~ ~ ~${value} ~-${result} ~-${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~${value} ~ ~ ~${value} ~-${i} ~-${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~${value} ~ ~ ~${value} ~${result} ~-${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~${value} ~ ~ ~${value} ~-${i} ~${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~${value} ~ ~ ~${value} ~-${result} ~${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~${value} ~ ~ ~${value} ~${i} ~-${result} ${id}`);
                }
            }
            else if (direction == "y") {
                for (let i = 0; i <= radius; i++) {
                    const result = Math.round(Math.sqrt((radius * radius) - (i * i)));
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~${value} ~ ~${result} ~${value} ~${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~${value} ~ ~${i} ~${value} ~${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~${value} ~ ~-${result} ~${value} ~-${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~${value} ~ ~-${i} ~${value} ~-${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~${value} ~ ~${result} ~${value} ~-${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~${value} ~ ~-${i} ~${value} ~${result} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~${value} ~ ~-${result} ~${value} ~${i} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~${value} ~ ~${i} ~${value} ~-${result} ${id}`);
                }
            }
            else if (direction == "z") {
                for (let i = 0; i <= radius; i++) {
                    const result = Math.round(Math.sqrt((radius * radius) - (i * i)));
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~ ~${value} ~${result} ~${i} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~ ~${value} ~${i} ~${result} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~ ~${value} ~-${result} ~-${i} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~ ~${value} ~-${i} ~-${result} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~ ~${value} ~${result} ~-${i} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~ ~${value} ~-${i} ~${result} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~ ~${value} ~-${result} ~${i} ~${value} ${id}`);
                    command(`execute @a[name=${playerName}] ^ ^ ^${caret} fill ~ ~ ~${value} ~${i} ~-${result} ~${value} ${id}`);
                }
            }
            else {
                this.error(playerName, "方向はx, y, zのみです");
                Commands.run(`testfor @s`);
            }
        }
    }
    static sphere(playerName, id, radius, caret = 0, hollow = false) {
        radius++;
        for (let i = 0; i <= radius; i++) {
            const result = Math.round(Math.sqrt((radius * radius) - (i * i)));
            this.circle(playerName, id, result - 1, "x", i, caret, hollow);
            this.circle(playerName, id, result - 1, "x", -i, caret, hollow);
            this.circle(playerName, id, result - 1, "y", i, caret, hollow);
            this.circle(playerName, id, result - 1, "y", -i, caret, hollow);
            this.circle(playerName, id, result - 1, "z", i, caret, hollow);
            this.circle(playerName, id, result - 1, "z", -i, caret, hollow);
        }
    }
    static error(playerName, message) {
        Commands.run(`tellraw @a[name=${playerName}] {"rawtext":[{"text":"§c${message}"}]}`);
        Commands.run(`execute @a[name=${playerName}] ~ ~ ~ playsound note.bass @a ^ ^ ^1 1 1 1`);
    }
}
